package uk.ac.bbsrc.babraham.SparkSpotter;
/*
 * SparkSpotter - An ImageJ plugin for finding bright sparks in movies
 * Copyright (c) 2007 Simon Andrews

 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class SparkSpotterProgressDialog extends JDialog implements Runnable, ActionListener {

	private JLabel label;
	private int current = 0;
	private int total = 1;
	private ProgressBar progressBar = new ProgressBar();
	private SparkSpotter_ parent;

	public SparkSpotterProgressDialog (SparkSpotter_ parent) {
		super(parent.getPrefs(),"Running Analysis...");
		this.parent = parent;
		setSize(300,100);
		setLocationRelativeTo(parent.getPrefs());
		
		label = new JLabel("Finding Sparks...",JLabel.CENTER);
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(label,BorderLayout.CENTER);
		
		JPanel bottomPanel = new JPanel();
		bottomPanel.setLayout(new BorderLayout());
		bottomPanel.add(progressBar,BorderLayout.CENTER);
		JButton cancelButton = new JButton("Cancel");
		cancelButton.addActionListener(this);
		bottomPanel.add(cancelButton,BorderLayout.EAST);
		getContentPane().add(bottomPanel,BorderLayout.SOUTH);
		Thread t = new Thread(this);
		t.start();
		setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
		setVisible(true);
	}
	
	public void run() {
		try {
			Thread.sleep(500);
		} catch (InterruptedException e) {}
	}

	public void updateProgress(int currentPos, int totalPos) {
		current = currentPos;
		total = totalPos;
		progressBar.repaint();
		
	}

	public void exceptionReceived(Exception e) {
		JOptionPane.showMessageDialog(this,e.getMessage(),"Error",JOptionPane.ERROR_MESSAGE);
		e.printStackTrace();
		setVisible(false);
		dispose();
	}

	public void processingFinished() {
		setVisible(false);
		dispose();
	}

	public void actionPerformed(ActionEvent e) {
		// This means the cancel button has been pressed.
		parent.cancelCalculation();
		setVisible(false);
		dispose();
		
	}

	private class ProgressBar extends JPanel {
		
		public void paint (Graphics g) {
			super.paint(g);
			g.setColor(Color.RED);
			g.fillRect(0,0,(int)(getWidth()*((float)current/total)),getHeight());
		}
		
	}

}
